<template>
  <div class="contSecc">
    <div class="gris">
      <!-- 
<input type="file" id="fileUpload" />
<input type="button" id="upload" value="Upload" onclick="Upload()" 
 hasSelection={this.state.fileLoaded}
    onInputChange={this.handleFileLoad}/>
<hr />
<div id="dvExcel"></div>
      -->
      <div class="contSecc">
        <div class="divBuscador">
          <div>
            <v-text-field
              v-model="search"
              class="buscador"
              append-icon="mdi-magnify"
              label="Buscar..."
              clearable
              single-line
              hide-details
            ></v-text-field>
          </div>
        </div>
        <!-- Boton añadir asignacion -->
        <div>
          <div class="btnCenter padding">
            <v-btn
              class="mt-5"
              color="primary"
              dark
              @click="dialogAsignacion=true , negocioSelecionado = null"
            >
              <strong style="fond-size : 16px; color:#000;">Añadir Asignacion</strong>
            </v-btn>
          </div>
        </div>

        <!--  tabla-->
        <v-data-table
          :headers="encabezadoAsignacion"
          :items="asignaciones"
          :page.sync="page"
          :items-per-page="itemsPerPage"
          @page-count="pageCount = $event"
          :search="search"
          class="tblGeneral tblAsignacionGerente"
        >
          <template v-slot:item.Eliminar="{ item }">
            <button @click="(dialogActualiza = true), (itemSeleccionado = item)">
              <strong>Actualizar</strong>
            </button>
          </template>
        </v-data-table>
        <!-- termina  tabla-->
        <!-- paginado
            <div class="text-center pt-10">
              <v-pagination v-model="page" :length="pageCount" class="paginador"></v-pagination>
          </div>
        -->
      </div>
      <!-- Dialog Elimina -->
      <v-dialog v-model="dialogElimina" max-width="800" persistent>
        <v-card class="padding">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong>¿Deseas eliminar la visita?</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <div>
              ¿Estás seguro que deseas eliminar la visita especial a:
              <strong>{{this.itemSeleccionado.eco}}</strong>
              <strong>{{this.itemSeleccionado.nombreCeco}} para</strong>
              <strong>{{this.itemSeleccionado.nombreUsuario}}</strong>
            </div>
            <div></div>
          </div>
          <div class="btnCenter">
            <v-btn color="grey" dark @click="dialogElimina = false" class="mr-10">
              <strong style="fond-size : 16px; ">No, Conservar visita</strong>
            </v-btn>
            <v-btn
              color="primary"
              dark
              class
              @click="(dialogConfimacion = true), (dialogElimina = false);   eliminaAsignacion(); "
            >
              <strong style="fond-size : 16px; color:  #000;">Si, eliminar visita</strong>
            </v-btn>
          </div>
        </v-card>
      </v-dialog>

      <!-- Dialog Confirmacion Eliminacion -->
      <v-dialog v-model="dialogConfimacion" max-width="600" persistent>
        <v-card class="padding">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong>Asignacion eliminada</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <div>
              La visita a:
              <strong>{{this.itemSeleccionado.econom}}</strong>
              <strong>{{this.itemSeleccionado.nombreSucursal}} para</strong>
              <strong>{{this.itemSeleccionado.nombreUsuario}}</strong>
              ,ha sido eliminada.
            </div>
          </div>
          <div class="btnCenter">
            <v-btn
              color="primary"
              dark
              @click="dialogConfimacionAlta = false;dialogConfimacion=false"
            >
              <strong style="fond-size : 16px; color:  #000; ">¡De acuerdo!</strong>
            </v-btn>
          </div>
        </v-card>
      </v-dialog>

      <!-- Dialog Actualiza -->
      <v-dialog v-model="dialogActualiza" persistent max-width="600px">
        <v-card>
          <div class="gris">
            <v-card-title class="headline">
              <div class="titModal">
                <div>
                  <strong>Actualiza Asignacion</strong>
                </div>
              </div>
            </v-card-title>

            <div class="contModal tCenter">
              <strong>Ingresa datos para la Reprogramacion</strong>
            </div>

            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Supervisor a asignar:</strong>
                <br />
                <div class="pRelative">
                  <v-autocomplete
                    ref="autoUsuarioAct"
                    v-model="usuarioEncontradoAct"
                    :items="metadata.usuarios"
                    clearable
                    append-icon
                    item-value="idUsuario"
                    item-text="nombreUsuario"
                    placeholder="Buscar Supervisor"
                    :search-input.sync="textoUsuarioIngresadoAct"
                    :rules="[!!usuarioEncontradoAct || 'Debes Seleccionar un usuario']"
                    :cache-items="false"
                    @keyup="actualizaUsuarios"
                    return-object
                  ></v-autocomplete>
                </div>
              </div>
            </div>
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Ceco a asignar:</strong>
                <br />
                <div class="pRelative">
                  <strong>{{this.itemSeleccionado.econom}}</strong>
                  <strong>{{this.itemSeleccionado.nombreSucursal}}</strong>
                </div>
              </div>
            </div>
            <!-- Gerente -->
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Coordinador a asignar:</strong>
                <br />
                <div class="pRelative">
                  <v-autocomplete
                    ref="autoGerente"
                    v-model="gerenteEncontradoAct"
                    :items="metadata.gerentes"
                    clearable
                    dense
                    hide-no-data
                    append-icon
                    item-value="idUsuario"
                    item-text="nombreUsuario"
                    placeholder="Buscar Coordinador"
                    :search-input.sync="textoGerenteAct"
                    :rules="[!!gerenteEncontradoAct || 'Debes Seleccionar un usuario']"
                    :cache-items="false"
                    @keyup="actualizaUsuariosGerentes"
                    return-object
                  ></v-autocomplete>
                </div>
              </div>
            </div>
            <!-- Comentario Reprogramacion -->
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Motivo:</strong>
                <br />
                <div class="pRelative">
                  <v-select
                    v-model="comentario"
                    label="Selecciona motivo"
                    :items="motivosReprograma"
                    persistent-hint
                    return-object
                    single-line
                  ></v-select>
                </div>
              </div>
            </div>
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Fecha Programacion Actual:</strong>
                <br />
                <div class="pRelative">
                  <strong>{{this.itemSeleccionado.fechaProgramada}}</strong>
                </div>
              </div>
            </div>
            <!-- Calendario -->
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Fecha Reprogramacion:</strong>
                <v-container grid-list-md>
                  <v-row justify="center">
                    <v-layout row wrap>
                      <v-flex xs12 lg6>
                        <v-menu
                          ref="menu2"
                          v-model="menu2"
                          :close-on-content-click="false"
                          :nudge-right="40"
                          transition="scale-transition"
                          offset-y
                          :cache-items="false"
                          max-width="290px"
                          min-width="290px"
                        >
                          <template v-slot:activator="{ on }">
                            <v-text-field
                              v-model="dateFormatted"
                              persistent-hint
                              readonly
                              placeholder="Fecha Reprogramacion"
                              @blur="date = parseDate(dateFormatted)"
                              :cache-items="false"
                              v-on="on"
                            ></v-text-field>
                          </template>
                          <v-date-picker
                            v-model="date"
                            :min="getToday(0)"
                            no-title
                            :cache-items="false"
                            @input="menu2 = false"
                          ></v-date-picker>
                        </v-menu>
                      </v-flex>
                    </v-layout>
                  </v-row>
                </v-container>
              </div>
            </div>

            <div class="btnCenter">
              <v-btn
                color="grey"
                dark
                @click="dialogActualiza=false;limpiaFormularioNvo(); textoUsuarioIngresadoAct =''; usuarioEncontradoAct = null"
                class="mr-10"
              >
                <strong style="fond-size :16px; color: #000;">Cancelar</strong>
              </v-btn>
              <v-btn
                color="primary"
                dark
                @click="dialogConfimacionActualiza=true;dialogAsignacion=false;"
              >
                <strong style="fond-size : 16px; color:  #000;">Guardar</strong>
              </v-btn>
            </div>
          </div>
        </v-card>
      </v-dialog>
      <!-- FIN ACTUALIZA-->

      <!-- Dialog Confirmacion Alta -->
      <v-dialog v-model="dialogConfimacionAlta" max-width="600" persistent>
        <v-card class="padding">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong>Visita Asignada</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <div>
              La Aignacion Se realizo a:
              <Strong>
                CECO:
                {{cecoSeleccionado.idCeco}} A
                {{usuarioEncontrado.nombreUsuario}}
              </Strong>,ha sido Asignada.
            </div>
          </div>
          <div class="btnCenter">
            <v-btn color="primary" dark @click="dialogConfimacionAlta = false;altaAsignacion();">
              <strong style="fond-size : 16px; color:  #000;">¡De acuerdo!</strong>
            </v-btn>
          </div>
        </v-card>
      </v-dialog>
      <!-- Dialog Confirmacion ACTUALIZA -->
      <v-dialog v-model="dialogConfimacionActualiza" max-width="600" persistent>
        <v-card class="padding">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong>Visita Reprogramada</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <div>
              La Aignacion Se Reprogramo a:
              <Strong>
                CECO:
                {{cecoSeleccionado.idCeco}} A
                {{usuarioEncontrado.nombreUsuario}}
                Fecha {{this.dateFormatted}}
              </Strong>,ha sido Reprogramada.
            </div>
          </div>
          <div class="btnCenter">
            <v-btn
              color="primary"
              dark
              @click="dialogConfimacionActualiza = false;dialogActualiza=false;actualizaAsignacionmtto();"
            >
              <strong style="fond-size : 16px; color:  #000;">¡De acuerdo!</strong>
            </v-btn>
          </div>
        </v-card>
      </v-dialog>

      <!-- Dialog dialogAsignacion -->

      <v-dialog v-model="dialogAsignacion" persistent max-width="600px">
        <v-card>
          <div class="gris">
            <v-card-title class="headline">
              <div class="titModal">
                <div>
                  <strong>Alta Asignacion</strong>
                </div>
              </div>
            </v-card-title>

            <div class="contModal tCenter">
              <strong>Ingresa datos para la asignación</strong>
            </div>

            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Negocio:</strong>
                <br />
                <div class="pRelative">
                  <v-select
                    v-model="negocioSelecionado"
                    label="Selecciona negocio"
                    :items="negocios"
                    item-text="descripcion"
                    item-value="prefijo"
                    persistent-hint
                    @change="getNegocioVersion()"
                    return-object
                    single-line
                  ></v-select>
                </div>
              </div>
            </div>
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Supervisor a asignar:</strong>
                <br />
                <div class="pRelative">
                  <v-autocomplete
                    ref="autoUsuario"
                    v-model="usuarioEncontrado"
                    :items="metadata.usuarios"
                    clearable
                    append-icon
                    item-value="idUsuario"
                    item-text="nombreUsuario"
                    placeholder="Buscar Supervisor"
                    :search-input.sync="textoUsuarioIngresado"
                    :rules="[!!usuarioEncontrado || 'Debes Seleccionar un usuario']"
                    :cache-items="false"
                    @keyup="actualizaUsuarios"
                    return-object
                  ></v-autocomplete>
                </div>
              </div>
            </div>

            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Ceco a asignar:</strong>
                <br />
                <div class="pRelative">
                  <v-autocomplete
                    ref="autoCeco"
                    v-model="cecoSeleccionado"
                    :items="metadata.cecos"
                    item-text="ceco"
                    clearable
                    dense
                    hide-no-data
                    append-icon
                    placeholder="Buscar Ceco"
                    :search-input.sync="textoIngresado"
                    :rules="[() => !!cecoSeleccionado || 'Debes seleccionar un ceco',]"
                    :cache-items="false"
                    @keyup="actualizaCecos"
                    return-object
                  ></v-autocomplete>
                  <input type="submit" class="buscar" value @click="getCecos()" />
                </div>
              </div>
            </div>
            <!-- Gerente -->
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>Coordinador a asignar:</strong>
                <br />
                <div class="pRelative">
                  <v-autocomplete
                    ref="autoGerente"
                    v-model="gerenteEncontrado"
                    :items="metadata.gerentes"
                    clearable
                    dense
                    hide-no-data
                    append-icon
                    item-value="idUsuario"
                    item-text="nombreUsuario"
                    placeholder="Buscar Coordinador"
                    :search-input.sync="textoGerente"
                    :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                    :cache-items="false"
                    @keyup="actualizaUsuariosGerentes"
                    return-object
                  ></v-autocomplete>
                </div>
              </div>
            </div>

            <!-- Calendario-->
            <div class="divCol spaceCol">
              <div class="col12">
                <strong>
                  Fecha Reprogramacion
                  :
                </strong>
                <v-container grid-list-md>
                  <v-row justify="center">
                    <v-layout row wrap>
                      <v-flex xs12 lg6>
                        <v-menu
                          ref="menu1"
                          v-model="menu1"
                          :close-on-content-click="false"
                          :nudge-right="40"
                          transition="scale-transition"
                          offset-y
                          :cache-items="false"
                          max-width="290px"
                          min-width="290px"
                        >
                          <template v-slot:activator="{ on }">
                            <v-text-field
                              v-model="dateFormatted"
                              persistent-hint
                              placeholder="Fecha Programacion"
                              @blur="date = parseDate(dateFormatted)"
                              :cache-items="false"
                              readonly
                              v-on="on"
                            ></v-text-field>
                          </template>
                          <v-date-picker
                            v-model="date"
                            no-title
                            :min="getToday(0)"
                            :cache-items="false"
                            @input="menu1 = false"
                          ></v-date-picker>
                        </v-menu>
                      </v-flex>
                    </v-layout>
                  </v-row>
                </v-container>
              </div>
            </div>

            <div class="btnCenter">
              <v-btn
                color="grey"
                dark
                @click="dialogAsignacion=false;limpiaFormulario(); textoUsuarioIngresadoAct= ''; usuarioEncontradoAct = null"
                class="mr-10"
              >
                <strong style="fond-size :16px; color: #000;">Cancelar</strong>
              </v-btn>
              <v-btn
                color="primary"
                dark
                @click="dialogConfimacionAlta=true;dialogAsignacion=false;"
              >
                <strong style="fond-size : 16px; color:  #000;">Guardar</strong>
              </v-btn>
            </div>
          </div>
        </v-card>
      </v-dialog>
    </div>
  </div>
</template>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
import moment from "moment";

export default {
  name: "tabla-visor-asignacion",

  data() {
    return {
      expNumerico: /^([0-9])*$/,
      negocios: [
        { prefijo: "92", descripcion: "EKT" },
        { prefijo: "48", descripcion: "DAZ" },
        { prefijo: "23", descripcion: "OCC" },
        { prefijo: "67", descripcion: "ITK" },
        { prefijo: "63", descripcion: "PP" },
        { prefijo: "69", descripcion: "ATM" },
        { prefijo: "77", descripcion: "MAZ" },
        { prefijo: "55", descripcion: "C3" }
      ],
      motivosReprograma: [
        "Incapacidad",
        "Tareas especiales agregadas",
        "Viáticos",
        "Falla en auto",
        "Sitio sin personal",
        "Condiciones climaticas",
        "Vacante"
      ],

      cecoIngresado: "",
      cecoSeleccionado: "",
      cecosEncontrados: [],
      usuarioEncontrado: "",
      usuarioEncontradoAct: "",
      textoIngresado: "",
      itemSeleccionado: "",
      negocioSelecionado: null,
      textoNegocioIngresado: "",
      textoUsuarioIngresado: "",
      textoUsuarioIngresadoAct: "",
      habilitaSuc: true,
      gerenteEncontrado: "",
      gerenteEncontradoAct: "",
      textoGerente: "",
      textoGerenteAct: "",
      muestraCalendario: false,
      comentario: "",
      idProyectoSeleccionado: 0,
      descripcionProyectoSeleccionado: "",
      //calendario
      menu: false,
      modal: false,
      menu1: false,
      date: new Date().toISOString().substr(0, 10),
      dateFormatted: "",
      dateFormattedRepro: "",
      dateRepro: new Date().toISOString().substr(0, 10),
      menu2: false,
      landscape: "",
      picker: "",
      //dialogs
      dialogConfimacionAlta: false,
      dialogElimina: false,
      dialogConfimacion: false,
      dialogAsignacion: false,
      dialogActualiza: false,
      dialogConfimacionActualiza: false,
      pageCount: 1,
      page: 1,
      itemsPerPage: 20,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10]
      },
      encabezadoAsignacion: [
        {
          text: "Programacion",
          value: "idProgramacion",
          align: "center"
        },
        {
          text: "Ceco",
          value: "econom",
          align: "center"
        },
        {
          text: "Nombre Sucursal",
          value: "nombreSucursal",
          align: "center"
        },
        {
          text: "No.Empleado",
          value: "idUsuario",
          align: "center"
        },
        {
          text: "Nombre Visitante",
          value: "nombreUsuario",
          align: "center"
        },
        {
          text: "FechaProgramada",
          value: "fechaProgramada",
          align: "center"
        },
        {
          text: "Fecha Programacion Anterior",
          value: "fechaProgramacionAntigua",
          align: "center"
        },

        {
          text: "Actualizar",
          value: "Eliminar",
          align: "center"
        }
      ],
      asignaciones: [],
      metadata: {
        cecos: [],
        usuarios: [],
        negocios: [],
        gerentes: []
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Protocolos",
          disabled: true
        }
      ]
    };
  },
  created() {
    this.getAsignaciones();
    // this.getNegocios();
  },
  methods: {
    getToday(addDay) {
      var date = new Date();
      date.setDate(date.getDate() + addDay);
      var fecha =
        date.getFullYear() +
        "-" +
        (date.getMonth() + 1 > 9
          ? date.getMonth() + 1
          : "0" + (date.getMonth() + 1)) +
        "-" +
        (date.getDate() > 9 ? date.getDate() : "0" + date.getDate());

      return fecha;
    },
    getAsignaciones() {
      axios
        //servicio viejo asignacion-sup/secure/post/asignacionsup
        //
        .post("/asignacion-mtto/secure/post/obtieneAsignacionesSupMtto", {
          //ES EL STATUS DE LAS ASIGNACIONES
          idProyecto: 1
          //idUsuario:null,
          //zona:null
        })
        .then(response => {
          if (response) {
            if (response.status === 200) {
              this.asignaciones = response.data.data;
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    eliminaAsignacion() {
      //alert(JSON.stringify(this.itemSeleccionado));

      axios
        .delete("/asignacion-mtto/secure/delete/asignacionMtto", {
          data: {
            idProyecto: 15,
            idCeco: this.itemSeleccionado.econom
          }
        })
        .then(response => {
          this.getAsignaciones();
          if (response === 200 && response.data === 1) {
            this.dialogConfimacion = true;
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    //Inicia cecos
    getCecos() {
      axios
        .post("negoVers/secure/post/cecos", {
          prefijo: this.prefijo,
          idCeco: this.ceco,
          nombreCeco: this.nombre
        })
        .then(response => {
          //console.log(JSON.stringify(response.data.data))
          if (response) {
            if (response.status === 200) {
              this.metadata.cecos = [];

              for (var i = 0; i < response.data.data.length; i++) {
                this.metadata.cecos.push({
                  nombreCeco: response.data.data[i].nombreCeco,
                  ceco:
                    response.data.data[i].nombreCeco +
                    " - " +
                    response.data.data[i].idCeco,
                  idCeco: response.data.data[i].idCeco
                });
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaCecos() {
      if (this.textoIngresado != null && this.textoIngresado.length > 3) {
        this.prefijo = this.negocioSelecionado.prefijo; // Se quita para buscar prefjo seleccionado

        if (this.expNumerico.test(this.textoIngresado)) {
          this.ceco = this.textoIngresado;
          this.nombre = null;
        } else {
          this.nombre = this.textoIngresado;
          this.ceco = null;
        }

        this.getCecos();
      } else {
        this.metadata.cecos = [];
      }
    },
    //finaliza cecos
    /* INICIA USUARIOS */
    getUsuarios() {
      axios
        .post("/negoVers/secure/post/usuarios", {
          id_usuario: this.idUsuario,
          nombreUsuario: this.nombreUsuario,
          idPuesto: 1
        })
        .then(response => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.usuarios = response.data.data;
                //console.log(JSON.stringify(this.metadata.usuarios))
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaUsuarios() {
      if (
        (this.textoUsuarioIngresadoAct != null &&
          this.textoUsuarioIngresadoAct.length > 3) ||
        (this.textoUsuarioIngresado != null &&
          this.textoUsuarioIngresado.length > 3)
      ) {
        this.getUsuarios();
      } else {
        this.metadata.usuarios = [];
      }
    },
    /* FIN USUARIOS */
    /* INICIA COORDINADORES */
    getUsuariosGerentes() {
      axios
        .post("/negoVers/secure/post/usuarios", {
          id_usuario: this.idUsuario,
          nombreUsuario: this.nombreUsuario,
          idPuesto: 2
        })
        .then(response => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.gerentes = response.data.data;
                this.muestraCalendario = true;
                //console.log("entro")
                // console.log(JSON.stringify(this.metadata.gerentes))
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaUsuariosGerentes() {
      if (
        (this.textoGerente != null && this.textoGerente.length > 3) ||
        (this.textoGerenteAct != null && this.textoGerenteAct.length > 3)
      ) {
        this.getUsuariosGerentes();
      } else {
        this.metadata.gerentes = [];
      }
    },

    //ALTA ASIGNACION
    altaAsignacion() {
      this.objAdd = {
        idUsuario: this.usuarioEncontrado.idUsuario,
        idCeco: this.cecoSeleccionado.idCeco,
        idProyecto: this.idProyectoSeleccionado,
        idAgrupa: this.idProyectoSeleccionado,
        usuarioAsigna: this.gerenteEncontrado.idUsuario,
        //fechaProgramada :this.picker.replace(/-/g,""),
        descripcion: this.negocioSelecionado.descripcion,
        fechaProgramada: moment(String(this.dateFormatted)).format("YYYYMMDD"),
        tipoVisita: "GENERAL"
        //moment(String(value)).format('MM/DD/YYYY hh:mm')
      };
      axios
        .post(
          "/asignacion-mtto/secure/post/alta/asignacionSupMtto",
          this.objAdd
        )
        .then(response => {
          //console.log(JSON.stringify(response))
          if (this.objAdd.idUsuario != null && this.objAdd.idCeco != null) {
            //alert("datos" + JSON.stringify(this.objAdd));
            if (response) {
              if (response.status == 200) {
                if (response.data.data == 1) {
                  this.dialog = false;
                  this.dialogConfimacionAlta = false;
                  this.dialogAsignacion = false;
                  this.getAsignaciones();
                  this.habilitaSuc = true;
                  this.dateFormatted = "";
                }
              } else {
                //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
                this.dialogFallo = true;
                this.habilitaSuc = true;
              }
            }
          } else {
            //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
            this.dialogFallo = true;
            this.usuarioEncontrado = "";
            this.cecoSeleccionado = "";
            this.listaTipoNego = "";
            this.metadata.cecos = [];
            this.metadata.usuarios = [];
            this.$refs.autoUsuario.resetValidation();
            this.$refs.autoCeco.resetValidation();
            this.$refs.autoGerente.resetValidation();
            this.dialogAsignacion = true;
            this.habilitaSuc = false;
            this.muestraCalendario = false;
            this.dateFormatted = "";
            //this.zona="";
            this.picker = "";
          }
          this.usuarioEncontrado = "";
          this.cecoSeleccionado = "";
          this.listaTipoNego = "";
          this.metadata.cecos = [];
          this.metadata.negocios = [];
          this.metadata.usuarios = [];
          this.metadata.gerentes = [];
          this.$refs.autoUsuario.resetValidation();
          this.$refs.autoCeco.resetValidation();
          this.$refs.autoGerente.resetValidation();
          this.muestraCalendario = false;
          this.dateFormatted = "";
          //this.zona="";
          this.picker = "";
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    limpiaFormulario() {
      this.usuarioEncontrado = "";
      this.cecoSeleccionado = "";
      this.listaTipoNego = "";
      this.metadata.cecos = [];
      this.metadata.negocios = [];
      this.metadata.usuarios = [];
      this.metadata.gerentes = [];
      this.$refs.autoUsuario.resetValidation();
      this.$refs.autoCeco.resetValidation();
      this.$refs.autoGerente.resetValidation();
      this.habilitaSuc = true;
      this.muestraCalendario = false;
      this.dateFormatted = "";
      this.date = "";
      this.picker = "";
      this.menu1 = "";
      this.comentario = "";
    },
    limpiaFormularioNvo() {
      this.usuarioEncontrado = "";
      this.cecoSeleccionado = "";
      this.listaTipoNego = "";
      this.metadata.cecos = [];
      this.metadata.negocios = [];
      this.metadata.usuarios = [];
      this.metadata.gerentes = [];
      this.$refs.autoUsuarioAct.resetValidation();
      this.$refs.autoCeco.resetValidation();
      this.$refs.autoGerente.resetValidation();
      this.dateFormatted = "";
      this.date = "";
      this.picker = "";
      this.menu1 = "";
      this.comentario = "";
      this.dialogConfimacionActualiza = false;
    },
    actualizaAsignacionmtto() {
      //alert(JSON.stringify(this.itemSeleccionado));
      this.objAdd = {
        idProgramacion: this.itemSeleccionado.idProgramacion,
        idUsuario: this.usuarioEncontradoAct.idUsuario,
        usuarioAsigna: this.gerenteEncontradoAct.idUsuario,
        //fechaProgramada :this.picker.replace(/-/g,""),
        comentarioReprogramacion: this.comentario,
        //fechaProgramada: moment(String(this.dateFormatted)).format('YYYYMMDD')
        fechaProgramada: moment(String(this.dateFormatted)).format("DDMMYY")

        /*moment(String(value)).format('MM/DD/YYYY hh:mm')
                 "idProgramacion":61,
                  "idUsuario":73610,
                  "comentarioReprogramacion":"Se programa para el dia de la candelaria",
                  "fechaProgramada":20210202*/
      };
      // alert(JSON.stringify(this.itemSeleccionado));
      // alert(JSON.stringify(this.objAdd));

      axios
        .put("/asignacion-mtto/secure/put/asignacionSupMtto", this.objAdd)
        .then(response => {
          this.getAsignaciones();
          if (response === 200 && response.data === 1) {
            this.dialogConfimacion = true;
            this.usuarioEncontrado = "";
            this.cecoSeleccionado = "";
            this.listaTipoNego = "";
            this.metadata.cecos = [];
            this.metadata.usuarios = [];
            this.$refs.autoUsuario.resetValidation();
            this.$refs.autoCeco.resetValidation();
            this.$refs.autoGerente.resetValidation();
            this.dialogAsignacion = true;
            this.habilitaSuc = false;
            this.muestraCalendario = false;
            this.dateFormatted = "";
            //this.zona="";
            this.picker = "";
            this.comentario = "";
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${month}/${day}/${year}`;
    },
    parseDate(date) {
      if (!date) return null;

      const [month, day, year] = date.split("/");
      return `${year}-${month.padStart(2, "0")}-${day.padStart(2, "0")}`;
    },
    getNegocioVersion() {
      switch (this.negocioSelecionado.prefijo) {
        case "92":
          this.idProyectoSeleccionado = 15;
          break;
        case "48":
          this.idProyectoSeleccionado = 16;
          break;
        case "23":
          this.idProyectoSeleccionado = 17;
          break;
        case "67":
          this.idProyectoSeleccionado = 18;
          break;
        case "62":
          this.idProyectoSeleccionado = 19;
          break;
        case "69":
          this.idProyectoSeleccionado = 20;
          break;
        case "77":
          this.idProyectoSeleccionado = 21;
          break;
        case "55":
          this.idProyectoSeleccionado = 22;
          break;
        default:
          this.idProyectoSeleccionado = 15;
      }
    }
  }, // fin metodos
  computed: {
    computedDateFormatted() {
      return this.formatDate(this.date);
    }
  },

  watch: {
    date(val) {
      this.dateFormatted = this.formatDate(this.date);
    }
  }
};
</script>

<style>
.padding {
  padding-bottom: 25px;
}
</style>
